;nyquist plug-in
;version 3
;type process
;categories "http://lv2plug.in/ns/lv2core/#DynamicsPlugin"
;name "Cross-fade A..."
;action "Processing..."
;info "Linear cross-fade test version A.\n\nTo create a cross-fade, the first part of the selection will fade out and the\nfinal part of the selection will fade in.\n\nThe length of each fade (and so the final duration of the cross-fade) will be\nthe length of the selection minus the length of the deleted section\ndivided by two.\n\n"

;control ddur "Delete from middle of selection" real "Seconds" 0 0 10

(setq dur (* 0.5 (- (get-duration 1) ddur)))

(if (> dur 0)(progn
   (setq out-env (abs-env
      (control-srate-abs *sound-srate*
         (pwlv 1 dur 0))))

   (setq in-env (abs-env
      (control-srate-abs *sound-srate*
         (pwlv 0 dur 1))))

   (sim
     (at 0 (mult out-env (extract-abs 0 dur (cue s))))
     (at 0  (mult in-env (extract-abs (- (get-duration 1) dur) (get-duration 1) (cue s))))))

   (if (= ddur 1)
      (format nil "Error.\nSelection length is too small to\ndelete ~a second from the middle." ddur)
      (format nil "Error.\nSelection length is too small to\ndelete ~a seconds from the middle." ddur)))
